> ## Documentation Index
> Fetch the complete documentation index at: https://cdktn.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Java: DataTerraformRemoteStateGcs

> CDKTN Core API Reference for DataTerraformRemoteStateGcs in Java.

## Initializers <a name="Initializers" id="cdktn.DataTerraformRemoteStateGcs.Initializer" />

```java theme={null}
import io.cdktn.cdktn.DataTerraformRemoteStateGcs;

DataTerraformRemoteStateGcs.Builder.create(Construct scope, java.lang.String id)
//  .defaults(java.util.Map<java.lang.String, java.lang.Object>)
//  .workspace(java.lang.String)
    .bucket(java.lang.String)
//  .accessToken(java.lang.String)
//  .credentials(java.lang.String)
//  .encryptionKey(java.lang.String)
//  .impersonateServiceAccount(java.lang.String)
//  .impersonateServiceAccountDelegates(java.util.List<java.lang.String>)
//  .kmsEncryptionKey(java.lang.String)
//  .prefix(java.lang.String)
//  .storeageCustomEndpoint(java.lang.String)
    .build();
```

| **Name**                                                                                                                                                  | **Type**                                                          | **Description**                                                                                                                                                                                                                                                                                           |
| --------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.scope">scope</a></code>                                                           | <code>software.constructs.Construct</code>                        | *No description.*                                                                                                                                                                                                                                                                                         |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.id">id</a></code>                                                                 | <code>java.lang.String</code>                                     | *No description.*                                                                                                                                                                                                                                                                                         |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.defaults">defaults</a></code>                                                     | <code>java.util.Map\< java.lang.String, java.lang.Object ></code> | *No description.*                                                                                                                                                                                                                                                                                         |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.workspace">workspace</a></code>                                                   | <code>java.lang.String</code>                                     | *No description.*                                                                                                                                                                                                                                                                                         |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.bucket">bucket</a></code>                                                         | <code>java.lang.String</code>                                     | (Required) The name of the GCS bucket.                                                                                                                                                                                                                                                                    |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.accessToken">accessToken</a></code>                                               | <code>java.lang.String</code>                                     | (Optional) A temporary \[OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access\_token will be used over the credentials field. |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.credentials">credentials</a></code>                                               | <code>java.lang.String</code>                                     | (Optional) Local path to Google Cloud Platform account credentials in JSON format.                                                                                                                                                                                                                        |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.encryptionKey">encryptionKey</a></code>                                           | <code>java.lang.String</code>                                     | (Optional) A 32 byte base64 encoded 'customer supplied encryption key' used to encrypt all state.                                                                                                                                                                                                         |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.impersonateServiceAccount">impersonateServiceAccount</a></code>                   | <code>java.lang.String</code>                                     | (Optional) The service account to impersonate for accessing the State Bucket.                                                                                                                                                                                                                             |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.impersonateServiceAccountDelegates">impersonateServiceAccountDelegates</a></code> | <code>java.util.List\< java.lang.String ></code>                  | (Optional) The delegation chain for an impersonating a service account.                                                                                                                                                                                                                                   |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.kmsEncryptionKey">kmsEncryptionKey</a></code>                                     | <code>java.lang.String</code>                                     | (Optional) A Cloud KMS key ('customer-managed encryption key') used when reading and writing state files in the bucket.                                                                                                                                                                                   |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.prefix">prefix</a></code>                                                         | <code>java.lang.String</code>                                     | (Optional) GCS prefix inside the bucket.                                                                                                                                                                                                                                                                  |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.storeageCustomEndpoint">storeageCustomEndpoint</a></code>                         | <code>java.lang.String</code>                                     | (Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b).                                                                                                                               |

***

### `scope`<sup>Required</sup> <a name="scope" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.scope" />

* *Type:* software.constructs.Construct

***

### `id`<sup>Required</sup> <a name="id" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.id" />

* *Type:* java.lang.String

***

### `defaults`<sup>Optional</sup> <a name="defaults" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.defaults" />

* *Type:* java.util.Map\< java.lang.String, java.lang.Object >

***

### `workspace`<sup>Optional</sup> <a name="workspace" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.workspace" />

* *Type:* java.lang.String

***

### `bucket`<sup>Required</sup> <a name="bucket" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.bucket" />

* *Type:* java.lang.String

(Required) The name of the GCS bucket.

This name must be globally unique.

***

### `accessToken`<sup>Optional</sup> <a name="accessToken" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.accessToken" />

* *Type:* java.lang.String

(Optional) A temporary \[OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access\_token will be used over the credentials field.

***

### `credentials`<sup>Optional</sup> <a name="credentials" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.credentials" />

* *Type:* java.lang.String

(Optional) Local path to Google Cloud Platform account credentials in JSON format.

If unset, Google Application Default Credentials are used.
The provided credentials must have Storage Object Admin role on the bucket.

Warning: if using the Google Cloud Platform provider as well,
it will also pick up the GOOGLE\_CREDENTIALS environment variable.

***

### `encryptionKey`<sup>Optional</sup> <a name="encryptionKey" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.encryptionKey" />

* *Type:* java.lang.String

(Optional) A 32 byte base64 encoded 'customer supplied encryption key' used to encrypt all state.

***

### `impersonateServiceAccount`<sup>Optional</sup> <a name="impersonateServiceAccount" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.impersonateServiceAccount" />

* *Type:* java.lang.String

(Optional) The service account to impersonate for accessing the State Bucket.

You must have roles/iam.serviceAccountTokenCreator role on that account for the impersonation to succeed.
If you are using a delegation chain, you can specify that using the impersonate\_service\_account\_delegates field.
Alternatively, this can be specified using the GOOGLE\_IMPERSONATE\_SERVICE\_ACCOUNT environment variable.

***

### `impersonateServiceAccountDelegates`<sup>Optional</sup> <a name="impersonateServiceAccountDelegates" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.impersonateServiceAccountDelegates" />

* *Type:* java.util.List\< java.lang.String >

(Optional) The delegation chain for an impersonating a service account.

***

### `kmsEncryptionKey`<sup>Optional</sup> <a name="kmsEncryptionKey" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.kmsEncryptionKey" />

* *Type:* java.lang.String

(Optional) A Cloud KMS key ('customer-managed encryption key') used when reading and writing state files in the bucket.

Format should be projects/\{\{project}}/locations/\{\{location}}/keyRings/\{\{keyRing}}/cryptoKeys/\{\{name}}.
For more information, including IAM requirements, see [Customer-managed Encryption Keys](https://cloud.google.com/storage/docs/encryption/customer-managed-keys).

***

### `prefix`<sup>Optional</sup> <a name="prefix" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.prefix" />

* *Type:* java.lang.String

(Optional) GCS prefix inside the bucket.

Named states for workspaces are stored in an object called \< prefix >/\< name >.tfstate.

***

### `storeageCustomEndpoint`<sup>Optional</sup> <a name="storeageCustomEndpoint" id="cdktn.DataTerraformRemoteStateGcs.Initializer.parameter.storeageCustomEndpoint" />

* *Type:* java.lang.String

(Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b).

[See here for more details](https://developer.hashicorp.com/terraform/language/settings/backends/gcs#storage_custom_endpoint)

***

## Methods <a name="Methods" id="Methods" />

| **Name**                                                                                                    | **Description**                                                                   |
| ----------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.toString">toString</a></code>                             | Returns a string representation of this construct.                                |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.with">with</a></code>                                     | Applies one or more mixins to this construct.                                     |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.addOverride">addOverride</a></code>                       | *No description.*                                                                 |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.overrideLogicalId">overrideLogicalId</a></code>           | Overrides the auto-generated logical ID with a specific ID.                       |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.resetOverrideLogicalId">resetOverrideLogicalId</a></code> | Resets a previously passed logical Id to use the auto-generated logical id again. |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.toHclTerraform">toHclTerraform</a></code>                 | Adds this resource to the terraform JSON output.                                  |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.toMetadata">toMetadata</a></code>                         | *No description.*                                                                 |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.toTerraform">toTerraform</a></code>                       | Adds this resource to the terraform JSON output.                                  |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.get">get</a></code>                                       | *No description.*                                                                 |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.getBoolean">getBoolean</a></code>                         | *No description.*                                                                 |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.getList">getList</a></code>                               | *No description.*                                                                 |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.getNumber">getNumber</a></code>                           | *No description.*                                                                 |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.getString">getString</a></code>                           | *No description.*                                                                 |

***

### `toString` <a name="toString" id="cdktn.DataTerraformRemoteStateGcs.toString" />

```java theme={null}
public java.lang.String toString()
```

Returns a string representation of this construct.

### `with` <a name="with" id="cdktn.DataTerraformRemoteStateGcs.with" />

```java theme={null}
public IConstruct with(IMixin... mixins)
```

Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the
start of the call, so constructs added by a mixin will not be visited.
Use multiple `with()` calls if subsequent mixins should apply to added
constructs.

#### `mixins`<sup>Required</sup> <a name="mixins" id="cdktn.DataTerraformRemoteStateGcs.with.parameter.mixins" />

* *Type:* software.constructs.IMixin...

The mixins to apply.

***

### `addOverride` <a name="addOverride" id="cdktn.DataTerraformRemoteStateGcs.addOverride" />

```java theme={null}
public void addOverride(java.lang.String path, java.lang.Object value)
```

#### `path`<sup>Required</sup> <a name="path" id="cdktn.DataTerraformRemoteStateGcs.addOverride.parameter.path" />

* *Type:* java.lang.String

***

#### `value`<sup>Required</sup> <a name="value" id="cdktn.DataTerraformRemoteStateGcs.addOverride.parameter.value" />

* *Type:* java.lang.Object

***

### `overrideLogicalId` <a name="overrideLogicalId" id="cdktn.DataTerraformRemoteStateGcs.overrideLogicalId" />

```java theme={null}
public void overrideLogicalId(java.lang.String newLogicalId)
```

Overrides the auto-generated logical ID with a specific ID.

#### `newLogicalId`<sup>Required</sup> <a name="newLogicalId" id="cdktn.DataTerraformRemoteStateGcs.overrideLogicalId.parameter.newLogicalId" />

* *Type:* java.lang.String

The new logical ID to use for this stack element.

***

### `resetOverrideLogicalId` <a name="resetOverrideLogicalId" id="cdktn.DataTerraformRemoteStateGcs.resetOverrideLogicalId" />

```java theme={null}
public void resetOverrideLogicalId()
```

Resets a previously passed logical Id to use the auto-generated logical id again.

### `toHclTerraform` <a name="toHclTerraform" id="cdktn.DataTerraformRemoteStateGcs.toHclTerraform" />

```java theme={null}
public java.lang.Object toHclTerraform()
```

Adds this resource to the terraform JSON output.

### `toMetadata` <a name="toMetadata" id="cdktn.DataTerraformRemoteStateGcs.toMetadata" />

```java theme={null}
public java.lang.Object toMetadata()
```

### `toTerraform` <a name="toTerraform" id="cdktn.DataTerraformRemoteStateGcs.toTerraform" />

```java theme={null}
public java.lang.Object toTerraform()
```

Adds this resource to the terraform JSON output.

### `get` <a name="get" id="cdktn.DataTerraformRemoteStateGcs.get" />

```java theme={null}
public IResolvable get(java.lang.String output)
```

#### `output`<sup>Required</sup> <a name="output" id="cdktn.DataTerraformRemoteStateGcs.get.parameter.output" />

* *Type:* java.lang.String

***

### `getBoolean` <a name="getBoolean" id="cdktn.DataTerraformRemoteStateGcs.getBoolean" />

```java theme={null}
public IResolvable getBoolean(java.lang.String output)
```

#### `output`<sup>Required</sup> <a name="output" id="cdktn.DataTerraformRemoteStateGcs.getBoolean.parameter.output" />

* *Type:* java.lang.String

***

### `getList` <a name="getList" id="cdktn.DataTerraformRemoteStateGcs.getList" />

```java theme={null}
public java.util.List<java.lang.String> getList(java.lang.String output)
```

#### `output`<sup>Required</sup> <a name="output" id="cdktn.DataTerraformRemoteStateGcs.getList.parameter.output" />

* *Type:* java.lang.String

***

### `getNumber` <a name="getNumber" id="cdktn.DataTerraformRemoteStateGcs.getNumber" />

```java theme={null}
public java.lang.Number getNumber(java.lang.String output)
```

#### `output`<sup>Required</sup> <a name="output" id="cdktn.DataTerraformRemoteStateGcs.getNumber.parameter.output" />

* *Type:* java.lang.String

***

### `getString` <a name="getString" id="cdktn.DataTerraformRemoteStateGcs.getString" />

```java theme={null}
public java.lang.String getString(java.lang.String output)
```

#### `output`<sup>Required</sup> <a name="output" id="cdktn.DataTerraformRemoteStateGcs.getString.parameter.output" />

* *Type:* java.lang.String

***

## Static Functions <a name="Static Functions" id="Static Functions" />

| **Name**                                                                                            | **Description**               |
| --------------------------------------------------------------------------------------------------- | ----------------------------- |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.isConstruct">isConstruct</a></code>               | Checks if `x` is a construct. |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.isTerraformElement">isTerraformElement</a></code> | *No description.*             |

***

### `isConstruct` <a name="isConstruct" id="cdktn.DataTerraformRemoteStateGcs.isConstruct" />

```java theme={null}
import io.cdktn.cdktn.DataTerraformRemoteStateGcs;

DataTerraformRemoteStateGcs.isConstruct(java.lang.Object x)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

#### `x`<sup>Required</sup> <a name="x" id="cdktn.DataTerraformRemoteStateGcs.isConstruct.parameter.x" />

* *Type:* java.lang.Object

Any object.

***

### `isTerraformElement` <a name="isTerraformElement" id="cdktn.DataTerraformRemoteStateGcs.isTerraformElement" />

```java theme={null}
import io.cdktn.cdktn.DataTerraformRemoteStateGcs;

DataTerraformRemoteStateGcs.isTerraformElement(java.lang.Object x)
```

#### `x`<sup>Required</sup> <a name="x" id="cdktn.DataTerraformRemoteStateGcs.isTerraformElement.parameter.x" />

* *Type:* java.lang.Object

***

## Properties <a name="Properties" id="Properties" />

| **Name**                                                                                                 | **Type**                                                        | **Description**   |
| -------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------- | ----------------- |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.property.node">node</a></code>                         | <code>software.constructs.Node</code>                           | The tree node.    |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.property.cdktfStack">cdktfStack</a></code>             | <code><a href="#cdktn.TerraformStack">TerraformStack</a></code> | *No description.* |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.property.fqn">fqn</a></code>                           | <code>java.lang.String</code>                                   | *No description.* |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.property.friendlyUniqueId">friendlyUniqueId</a></code> | <code>java.lang.String</code>                                   | *No description.* |

***

### `node`<sup>Required</sup> <a name="node" id="cdktn.DataTerraformRemoteStateGcs.property.node" />

```java theme={null}
public Node getNode();
```

* *Type:* software.constructs.Node

The tree node.

***

### `cdktfStack`<sup>Required</sup> <a name="cdktfStack" id="cdktn.DataTerraformRemoteStateGcs.property.cdktfStack" />

```java theme={null}
public TerraformStack getCdktfStack();
```

* *Type:* <a href="#cdktn.TerraformStack">TerraformStack</a>

***

### `fqn`<sup>Required</sup> <a name="fqn" id="cdktn.DataTerraformRemoteStateGcs.property.fqn" />

```java theme={null}
public java.lang.String getFqn();
```

* *Type:* java.lang.String

***

### `friendlyUniqueId`<sup>Required</sup> <a name="friendlyUniqueId" id="cdktn.DataTerraformRemoteStateGcs.property.friendlyUniqueId" />

```java theme={null}
public java.lang.String getFriendlyUniqueId();
```

* *Type:* java.lang.String

***

## Constants <a name="Constants" id="Constants" />

| **Name**                                                                                             | **Type**                      | **Description**   |
| ---------------------------------------------------------------------------------------------------- | ----------------------------- | ----------------- |
| <code><a href="#cdktn.DataTerraformRemoteStateGcs.property.tfResourceType">tfResourceType</a></code> | <code>java.lang.String</code> | *No description.* |

***

### `tfResourceType`<sup>Required</sup> <a name="tfResourceType" id="cdktn.DataTerraformRemoteStateGcs.property.tfResourceType" />

```java theme={null}
public java.lang.String getTfResourceType();
```

* *Type:* java.lang.String

***
